/* iPulsar      Scale(  - ), 
                    High  Low. 
            ,  ""  . 
             : 
            1.    .  ,  
               Scale,    . 
            2.    ( ).  
               ,  ""   
             ,      ,   
             . */
#property   copyright "Copyright 2012,  .."
#property   link      "alextar@bk.ru"
#property   indicator_separate_window  //  
#property   indicator_buffers 2
#property   indicator_color1 Magenta   //  
#property   indicator_width1 2
#property   indicator_color2 Teal
#property   indicator_width2 2
#define     Version  "iPulsar_v3"      // 
#define     Zero     0.00000001
int            Hval, Lval,             //  
               Signals;
datetime       HT,      LT;            //   
double         HP[],    LP[],          // 
               Periods;                //     
extern bool    =true;
extern int     SignalFilter     =120,  //    
               Scale            =1440, //  
               ScaleDigits      =0;    //   
extern double  LevelFilter      =5;    //   ,  ...
//+------------------------------------------------------------------+
int init(){
   IndicatorShortName(Version);        //  
   IndicatorDigits(ScaleDigits);
   SetIndexLabel(0,"High");            //  
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,HP);
   SetIndexLabel(1,"Low");
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,LP);
   if( Scale==0 ) Scale=Period();      //   
   if( Scale<0  ) Scale=-Scale;
   if( ScaleDigits>8 ) ScaleDigits=8;
   if( ScaleDigits<0 ) ScaleDigits=-ScaleDigits;
   Periods=Scale/Period();             //   
   HT     =0;
   LT     =0;
   Signals=0;
   return(0);
}
//+------------------------------------------------------------------+
int start(){
   double f=LevelFilter*Periods, H, L, HB, LB;
   bool HD, LD;                        //   
   int i, k, Hbar, Lbar, History=Bars-1;
   if( HT>0 ) Hbar=iBarShift(NULL,0,HT);
   if( LT>0 ) Lbar=iBarShift(NULL,0,LT);
   int j=History-IndicatorCounted();   //  
   while( j>=0 ){
      H=High[j];
      L=Low[j];
      HD=false;
      LD=false;
      HB=0;                            //     High
      LB=0;                            //     Low
      i=j;
      while( i<History ){              //  
         if(  HD && LD ) break;        //  
         i++;
         k=i-j-1;                      //   
         if( !HD && High[i]-H>Zero ){
            HD=true;                   //  High
            if( k-f>-Zero ){           //  
               if( ! ){
                  HB=k;
                  Signals++;
               }
               else HB=Signal(j,k,Hbar,Hval,HT,Lbar,Lval,LT);
         }  }
         if( !LD && L-Low[i]>Zero ){
            LD=true;                   //  Low
            if( k-f>-Zero ){           //  
               if( ! ){
                  LB=k;
                  Signals++;
               }
               else LB=Signal(j,k,Lbar,Lval,LT,Hbar,Hval,HT);
      }  }  }
      //   :
      if( ! ){
         if( !HD ){
            HB=History-j-2;
            Signals++;
         }
         if( !LD ){
            LB=History-j-2;
            Signals++;
      }  }
      //      :
      HP[j]= NormalizeDouble(HB/Periods,ScaleDigits);
      LP[j]=-NormalizeDouble(LB/Periods,ScaleDigits);
      j--;
   }
   return(0);
}
//+------------------------------------------------------------------+
double Signal(int       Bar,           //  
              int       Val,           //  
              int&      Bar0,          //  
              int&      Val0,          //  
              datetime& T,             //  
              int&      contrBar,      //   
              int&      contrVal,      //   
              datetime& contrT){       //   
   int I=Val-Val0-(Bar0-Bar);          //   
   double S;                           //   
   if( I>=SignalFilter ){              //   
      Signals++;
      S       =Val;                    //   
      Bar0    =Bar;
      Val0    =Val;
      T       =Time[Bar];
      if( Bar<contrBar ){
         contrBar=0;                   //    
         contrVal=0;
         contrT  =0;
   }  }
   return(S);
}